unit Banner;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  tDirection = (dirRightLeft, dirBottomTop);

  TBanner = class(TCustomLabel)
  private
    { Private declarations }
    tm       : ttimer;
    st       : tStringList;
    index    : integer;
    x,y      : integer;
    l_Gap    : integer;
    l_Step   : integer;
    sstr     : string;
    GetSrc   : boolean;
    l_Dir    : TDirection;
    FOnEndList  : TNotifyEvent;
    FOnSize     : TNotifyEvent;
    FOnActivate : TNotifyEvent;
    FOnClick    : TNotifyEvent;
    FOnDblClick : TNotifyEvent;
    FOnMouseDown: TMouseEvent;
    FOnMouseUp  : TMouseEvent;
    FOnMouseMove: TMouseMoveEvent;
    function ReadRun : boolean;
    procedure WriteRun(value : boolean);
    function ReadSpeed : integer;
    procedure WriteSpeed(Value : integer);
    procedure WriteSt(value : TStringList);
    procedure WriteDir(value : TDirection);
    procedure WriteGap(value : integer);
    procedure GetLine;
    procedure WMActivate(var Message: TWMActivate); message WM_ACTIVATE;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure WMLButtonDblclk(var Message: TWMLButtonDblclk); message WM_LBUTTONDBLCLK;
    procedure WMRButtonDown(var Message: TWMRButtonDown); message WM_RBUTTONDOWN;
    procedure WMRButtonUp(var Message: TWMRButtonUp); message WM_RBUTTONUP;
    procedure WMRButtonDblclk(var Message: TWMRButtonDblclk); message WM_RBUTTONDBLCLK;
  protected
    { Protected declarations }
    procedure paint; override;
  public
    { Public declarations }
    constructor create(AOwner : TComponent); override;
    procedure Step(Sender : TObject);
  published
    { Published declarations }
    property Run : boolean read ReadRun write WriteRun;
    property Lines : tStringList read st write WriteSt;
    property Speed : integer read ReadSpeed write WriteSpeed;
    property Gap : integer read l_Gap write WriteGap;
    property Jump : integer read l_Step write l_Step;
    property Direction : TDirection read l_dir write WriteDir;
    property Alignment;
    property Transparent;
    property Color;
    property Font;
    property OnEndList  : TNotifyEvent read FOnEndList write FOnEndList;
    property OnSize     : TNotifyEvent read FOnSize write FOnSize;
    property OnActivate : TNotifyEvent read FOnActivate write FOnActivate;
    property OnClick    : TNotifyEvent read FOnClick write FOnClick;
    property OnDblClick : TNotifyEvent read FOnDblClick write FOnDblClick;
    property OnMouseDown: TMouseEvent read FOnMouseDown write FOnMouseDown;
    property OnMouseUp  : TMouseEvent read FOnMouseUp write FOnMouseUp;
    property OnMouseMove: TMouseMoveEvent read FOnMouseMove write FOnMouseMove;
  end;

procedure Register;

{  if Assigned(FOnChange) then FOnChange(Self);}

implementation

procedure TBanner.WMMouseMove;
var
 sh : tShiftState;
begin
if Assigned(FOnMouseMove) then
  begin
  sh:=[];
  if (message.Keys and MK_LBUTTON) <> 0 then
    sh:=sh+[ssLeft];
  if (message.Keys and MK_RBUTTON) <> 0 then
    sh:=sh+[ssRight];
  if (message.Keys and MK_MBUTTON) <> 0 then
    sh:=sh+[ssMiddle];
  if (message.Keys and MK_CONTROL) <> 0 then
    sh:=sh+[ssCtrl];
  if (message.Keys and MK_SHIFT) <> 0 then
    sh:=sh+[ssShift];
  FOnMouseMove(Self,sh,Message.XPos,Message.YPos);
  end;
end;

procedure TBanner.WMLButtonDown;
var
 sh : tShiftState;
begin
if Assigned(FOnMouseDown) then
  begin
  sh:=[];
  if (message.Keys and MK_LBUTTON) <> 0 then
    sh:=sh+[ssLeft];
  if (message.Keys and MK_RBUTTON) <> 0 then
    sh:=sh+[ssRight];
  if (message.Keys and MK_MBUTTON) <> 0 then
    sh:=sh+[ssMiddle];
  if (message.Keys and MK_CONTROL) <> 0 then
    sh:=sh+[ssCtrl];
  if (message.Keys and MK_SHIFT) <> 0 then
    sh:=sh+[ssShift];
  FOnMouseDown(Self,mbLeft,sh,Message.XPos,Message.YPos);
  end;
if Assigned(FOnClick) then FOnClick(Self);
end;

procedure TBanner.WMLButtonUp;
var
 sh : tShiftState;
begin
if Assigned(FOnMouseUp) then
  begin
  sh:=[];
  if (message.Keys and MK_LBUTTON) <> 0 then
    sh:=sh+[ssLeft];
  if (message.Keys and MK_RBUTTON) <> 0 then
    sh:=sh+[ssRight];
  if (message.Keys and MK_MBUTTON) <> 0 then
    sh:=sh+[ssMiddle];
  if (message.Keys and MK_CONTROL) <> 0 then
    sh:=sh+[ssCtrl];
  if (message.Keys and MK_SHIFT) <> 0 then
    sh:=sh+[ssShift];
  FOnMouseUp(Self,mbLeft,sh,Message.XPos,Message.YPos);
  end;
end;

procedure TBanner.WMLButtonDblclk;
var
 sh : tShiftState;
begin
if Assigned(FOnMouseDown) then
  begin
  sh:=[];
  if (message.Keys and MK_LBUTTON) <> 0 then
    sh:=sh+[ssLeft];
  if (message.Keys and MK_RBUTTON) <> 0 then
    sh:=sh+[ssRight];
  if (message.Keys and MK_MBUTTON) <> 0 then
    sh:=sh+[ssMiddle];
  if (message.Keys and MK_CONTROL) <> 0 then
    sh:=sh+[ssCtrl];
  if (message.Keys and MK_SHIFT) <> 0 then
    sh:=sh+[ssShift];
  sh:=sh+[ssDouble];
  FOnMouseDown(Self,mbLeft,sh,Message.XPos,Message.YPos);
  end;
if Assigned(FOnDblClick) then FOnDblClick(Self);
end;

procedure TBanner.WMRButtonDown;
var
 sh : tShiftState;
begin
if Assigned(FOnMouseDown) then
  begin
  sh:=[];
  if (message.Keys and MK_LBUTTON) <> 0 then
    sh:=sh+[ssLeft];
  if (message.Keys and MK_RBUTTON) <> 0 then
    sh:=sh+[ssRight];
  if (message.Keys and MK_MBUTTON) <> 0 then
    sh:=sh+[ssMiddle];
  if (message.Keys and MK_CONTROL) <> 0 then
    sh:=sh+[ssCtrl];
  if (message.Keys and MK_SHIFT) <> 0 then
    sh:=sh+[ssShift];
  FOnMouseDown(Self,mbRight,sh,Message.XPos,Message.YPos);
  end;
if Assigned(FOnClick) then FOnClick(Self);
end;

procedure TBanner.WMRButtonUp;
var
 sh : tShiftState;
begin
if Assigned(FOnMouseUp) then
  begin
  sh:=[];
  if (message.Keys and MK_LBUTTON) <> 0 then
    sh:=sh+[ssLeft];
  if (message.Keys and MK_RBUTTON) <> 0 then
    sh:=sh+[ssRight];
  if (message.Keys and MK_MBUTTON) <> 0 then
    sh:=sh+[ssMiddle];
  if (message.Keys and MK_CONTROL) <> 0 then
    sh:=sh+[ssCtrl];
  if (message.Keys and MK_SHIFT) <> 0 then
    sh:=sh+[ssShift];
  FOnMouseUp(Self,mbRight,sh,Message.XPos,Message.YPos);
  end;
end;

procedure TBanner.WMRButtonDblclk;
var
 sh : tShiftState;
begin
if Assigned(FOnMouseDown) then
  begin
  sh:=[];
  if (message.Keys and MK_LBUTTON) <> 0 then
    sh:=sh+[ssLeft];
  if (message.Keys and MK_RBUTTON) <> 0 then
    sh:=sh+[ssRight];
  if (message.Keys and MK_MBUTTON) <> 0 then
    sh:=sh+[ssMiddle];
  if (message.Keys and MK_CONTROL) <> 0 then
    sh:=sh+[ssCtrl];
  if (message.Keys and MK_SHIFT) <> 0 then
    sh:=sh+[ssShift];
  sh:=sh+[ssDouble];
  FOnMouseDown(Self,mbRight,sh,Message.XPos,Message.YPos);
  end;
if Assigned(FOnDblClick) then FOnDblClick(Self);
end;

procedure TBanner.WMActivate;
begin
if Assigned(FOnActivate) then FOnActivate(Self);
end;

procedure TBanner.WMSize;
begin
if l_Dir = dirRightLeft then
  begin
  y:=0;
  x:=width;
  end
else
  begin
  x:=0;
  y:=height;
  end;
if Assigned(FOnSize) then FOnSize(Self);
end;

procedure TBanner.paint;
var
 mDC,tDC,pDC : hDC;
 b1 : hBitmap;
 p : tWinControl;
 pos : integer;
 i : integer;
 s : string;
begin
if caption <> '' then
  caption:='';
if transparent then
  begin
  p:=parent;
  pDC:=GetDC(p.handle);
  mDC:=CreateCompatibleDC(canvas.handle);
  b1:=CreateCompatibleBitmap(canvas.handle,width,height);
  b1:=SelectObject(mDC,b1);
  tDC:=canvas.Handle;
  Canvas.handle:=mDC;
  BitBlt(mDC,0,0,width,height,pDC,left,top,SRCCOPY);
  canvas.font:=font;
  if l_gap > 0 then
    begin
    if l_Dir = dirRightLeft then
      begin
      pos:=x;
      i:=index;
      s:=sstr;
      while true do
        begin
        canvas.TextOut(pos,y,s);
        pos:=pos+canvas.textwidth(s)+gap;
        if (i = 0) or (i >= st.Count) or (pos >= width) then
          break
        else
          begin
          s:=st[i];
          inc(i);
          end;
        end;
      end
    else
      begin
      pos:=y;
      i:=index;
      s:=sstr;
      while true do
        begin
        case Alignment of
          taLeftJustify:  x:=0;
          taRightJustify: x:=width-canvas.TextWidth(s);
          taCenter:       x:=trunc((width-canvas.TextWidth(s))/2);
          end;
        canvas.TextOut(x,pos,s);
        pos:=pos+gap;
        if (i = 0) or (i >= st.Count) or (pos >= height) then
          break
        else
          begin
          s:=st[i];
          inc(i);
          end;
        end;
      end;
    end
  else
    canvas.TextOut(x,y,sstr);
  canvas.handle:=tDC;
  BitBlt(canvas.handle,0,0,width,height,mDC,0,0,SRCCOPY);
  b1:=SelectObject(mDC,b1);
  DeleteObject(b1);
  DeleteDC(mDC);
  ReleaseDC(p.handle,pDC);
  end
else
  begin
  mDC:=CreateCompatibleDC(canvas.handle);
  b1:=CreateCompatibleBitmap(canvas.handle,width,height);
  b1:=SelectObject(mDC,b1);
  tDC:=canvas.Handle;
  Canvas.handle:=mDC;
  inherited paint;
  if l_gap > 0 then
    begin
    if l_Dir = dirRightLeft then
      begin
      pos:=x;
      i:=index;
      s:=sstr;
      while true do
        begin
        canvas.TextOut(pos,y,s);
        pos:=pos+canvas.textwidth(s)+gap;
        if (i = 0) or (i >= st.Count) or (pos >= width) then
          break
        else
          begin
          s:=st[i];
          inc(i);
          end;
        end;
      end
    else
      begin
      pos:=y;
      i:=index;
      s:=sstr;
      while true do
        begin
        case Alignment of
          taLeftJustify:  x:=0;
          taRightJustify: x:=width-canvas.TextWidth(s);
          taCenter:       x:=trunc((width-canvas.TextWidth(s))/2);
          end;
        canvas.TextOut(x,pos,s);
        pos:=pos+gap;
        if (i = 0) or (i >= st.Count) or (pos >= height) then
          break
        else
          begin
          s:=st[i];
          inc(i);
          end;
        end;
      end;
    end
  else
    canvas.TextOut(x,y,sstr);
  canvas.handle:=tDC;
  BitBlt(canvas.handle,0,0,width,height,mDC,0,0,SRCCOPY);
  b1:=SelectObject(mDC,b1);
  DeleteObject(b1);
  DeleteDC(mDC);
  end;
end;

constructor TBanner.Create;
begin
inherited create(AOwner);
GetSrc:=true;
Index:=0;
autosize:=false;
width:=70;
height:=18;
l_Gap:=0;
l_Step:=2;
l_Dir:=dirRightLeft;
tm:=ttimer.create(self);
tm.enabled:=false;
tm.interval:=50;
tm.OnTimer:=Step;
st:=tStringList.create;
{------------------------}
st.add('TBanner component for Delphi 4');
st.add('(C) Drt., 1999');
st.add('Please, mail a bug reports to: drtinus@yahoo.com');
{------------------------}
sstr:='';
GetLine;
end;

procedure TBanner.Step;
var
 i : integer;
begin
if GetSrc then
  begin
  if l_Dir = dirRightLeft then
    begin
    y:=0;
    x:=width;
    end
  else
    begin
    x:=0;
    y:=height;
    end;
  GetSrc:=false;
  end;
if l_Dir = dirRightLeft then
  begin
  if gap = 0 then
    begin
    if x+canvas.textwidth(sstr) < 0 then
      begin
      GetLine;
      x:=width;
      end
    else
      dec(x,l_Step);
    end
  else
    begin
    if index >= st.count then
      i:=x+canvas.textwidth(sstr)
    else
      i:=x+canvas.textwidth(sstr)+gap;
    if i < 0 then
      begin
      GetLine;
      if index = 1 then
        x:=width
      else
        x:=i;
      end
    else
      dec(x,l_Step);
    end;
  end
else
  begin
  i:=y+gap;
  if i < 0 then
    begin
    GetLine;
    if index = 1 then
      y:=height
    else
      y:=i;
    end
  else
    dec(y,l_Step);
  end;
refresh;
end;

procedure TBanner.GetLine;
begin
sstr:='';
if st = nil then
  exit;
if st.count = 0 then
  begin
  if Assigned(FOnEndList) then FOnEndList(Self);
  exit;
  end;
sstr:=st[Index];
if (Index+1) >= st.count then
  begin
  Index:=0;
  if Assigned(FOnEndList) then FOnEndList(Self);
  end
else
  inc(Index);
end;

procedure TBanner.WriteSt(value : TStringList);
begin
st.Assign(value);
if l_Dir = dirRightLeft then
  begin
  y:=0;
  x:=width;
  end
else
  begin
  x:=0;
  y:=height;
  end;
index:=0;
GetLine;
refresh;
end;

function TBanner.ReadRun : boolean;
begin
result:=tm.enabled;
end;

procedure TBanner.WriteRun(value : boolean);
begin
tm.enabled:=value;
if l_Dir = dirRightLeft then
  begin
  y:=0;
  x:=width;
  end
else
  begin
  y:=height;
  x:=0;
  end;
end;

procedure TBanner.WriteDir(value : TDirection);
begin
l_Dir:=value;
if l_Dir = dirRightLeft then
  begin
  y:=0;
  if csDesigning in componentstate then
    gap:=0;
  end
else
  begin
  if csDesigning in componentstate then
    begin
    gap:=canvas.TextHeight(sstr)+5;
    Alignment:=taCenter;
    end;
  end;
refresh;
end;

function TBanner.ReadSpeed : integer;
begin
result:=round(10000/tm.interval);
end;

procedure TBanner.WriteSpeed(Value : integer);
begin
if value > 200 then
  value:=200;
if value < 2 then
  value:=2;
tm.Interval:=round(10000/value);
end;

procedure TBanner.WriteGap(value : integer);
begin
l_Gap:=value;
refresh;
end;

procedure Register;
begin
  RegisterComponents('Drt', [TBanner]);
end;

end.
